Index: src/UIElements/Dialog.hpp
===================================================================
--- src/UIElements/Dialog.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Dialog.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -20,10 +20,11 @@
 
 #include <boost/filesystem.hpp>
-#include "Box.hpp"
+#include "LinearAlgebra/RealSpaceMatrix.hpp"
 #include "LinearAlgebra/Vector.hpp"
 #include "RandomNumbers/RandomNumberDistribution_Parameters.hpp"
+#include "Parameters/Parameter.hpp"
 
 class atom;
-class Box;
+class RealSpaceMatrix;
 class element;
 class molecule;
@@ -155,28 +156,28 @@
   virtual ~Dialog();
 
-  template <class T> void query(const char *, std::string = "");
+  template <class T> void query(Parameter<T> &, const char *, std::string = "");
 
   virtual void queryEmpty(const char *, std::string = "")=0;
-  virtual void queryBoolean(const char *, std::string = "")=0;
-  virtual void queryInt(const char *, std::string = "")=0;
-  virtual void queryInts(const char *, std::string = "")=0;
-  virtual void queryUnsignedInt(const char *, std::string = "")=0;
-  virtual void queryUnsignedInts(const char *, std::string = "")=0;
-  virtual void queryDouble(const char*, std::string = "")=0;
-  virtual void queryDoubles(const char*, std::string = "")=0;
-  virtual void queryString(const char*, std::string = "")=0;
-  virtual void queryStrings(const char*, std::string = "")=0;
-  virtual void queryAtom(const char*,std::string = "")=0;
-  virtual void queryAtoms(const char*,std::string = "")=0;
-  virtual void queryMolecule(const char*, std::string = "")=0;
-  virtual void queryMolecules(const char*, std::string = "")=0;
-  virtual void queryVector(const char*,bool, std::string = "")=0;
-  virtual void queryVectors(const char*,bool, std::string = "")=0;
-  virtual void queryBox(const char*, std::string = "")=0;
-  virtual void queryElement(const char*, std::string = "")=0;
-  virtual void queryElements(const char*, std::string = "")=0;
-  virtual void queryFile(const char*, std::string = "")=0;
-  virtual void queryFiles(const char*, std::string = "")=0;
-  virtual void queryRandomNumberDistribution_Parameters(const char*, std::string = "")=0;
+  virtual void queryBoolean(Parameter<bool> &, const char *, std::string = "")=0;
+  virtual void queryInt(Parameter<int> &, const char *, std::string = "")=0;
+  virtual void queryInts(Parameter<std::vector<int> > &, const char *, std::string = "")=0;
+  virtual void queryUnsignedInt(Parameter<unsigned int> &, const char *, std::string = "")=0;
+  virtual void queryUnsignedInts(Parameter<std::vector<unsigned int> > &, const char *, std::string = "")=0;
+  virtual void queryDouble(Parameter<double> &, const char*, std::string = "")=0;
+  virtual void queryDoubles(Parameter<std::vector<double> > &, const char*, std::string = "")=0;
+  virtual void queryString(Parameter<std::string> &, const char*, std::string = "")=0;
+  virtual void queryStrings(Parameter<std::vector<std::string> > &, const char*, std::string = "")=0;
+  virtual void queryAtom(Parameter<const atom *> &, const char*,std::string = "")=0;
+  virtual void queryAtoms(Parameter<std::vector<const atom *> > &, const char*,std::string = "")=0;
+  virtual void queryMolecule(Parameter<const molecule *> &, const char*, std::string = "")=0;
+  virtual void queryMolecules(Parameter<std::vector<const molecule *> > &, const char*, std::string = "")=0;
+  virtual void queryVector(Parameter<Vector> &, const char*,bool, std::string = "")=0;
+  virtual void queryVectors(Parameter<std::vector<Vector> > &, const char*,bool, std::string = "")=0;
+  virtual void queryRealSpaceMatrix(Parameter<RealSpaceMatrix> &, const char*, std::string = "")=0;
+  virtual void queryElement(Parameter<const element *> &, const char*, std::string = "")=0;
+  virtual void queryElements(Parameter<std::vector<const element *> > &, const char*, std::string = "")=0;
+  virtual void queryFile(Parameter<boost::filesystem::path> &, const char*, std::string = "")=0;
+  virtual void queryFiles(Parameter< std::vector<boost::filesystem::path> > &, const char*, std::string = "")=0;
+  virtual void queryRandomNumberDistribution_Parameters(Parameter<RandomNumberDistribution_Parameters> &, const char*, std::string = "")=0;
 
   virtual bool display();
@@ -265,25 +266,25 @@
   class BooleanQuery : public Query {
   public:
-    BooleanQuery(std::string title, std::string _description = "");
+    BooleanQuery(Parameter<bool> &param, std::string title, std::string _description = "");
     virtual ~BooleanQuery();
     virtual bool handle()=0;
     virtual void setResult();
   protected:
-    bool tmp;
+    Parameter<bool> &tmp;
   };
 
   class IntQuery : public Query {
   public:
-    IntQuery(std::string title, std::string _description = "");
+    IntQuery(Parameter<int> &param, std::string title, std::string _description = "");
     virtual ~IntQuery();
     virtual bool handle()=0;
     virtual void setResult();
   protected:
-    int tmp;
+    Parameter<int> &tmp;
   };
 
   class IntsQuery : public Query {
   public:
-    IntsQuery(std::string title, std::string _description = "");
+    IntsQuery(Parameter<std::vector<int> > &, std::string title, std::string _description = "");
     virtual ~IntsQuery();
     virtual bool handle()=0;
@@ -291,20 +292,20 @@
   protected:
     int temp;
-    std::vector<int> tmp;
+    Parameter<std::vector<int> > &tmp;
   };
 
   class UnsignedIntQuery : public Query {
   public:
-    UnsignedIntQuery(std::string title, std::string _description = "");
+    UnsignedIntQuery(Parameter<unsigned int> &, std::string title, std::string _description = "");
     virtual ~UnsignedIntQuery();
     virtual bool handle()=0;
     virtual void setResult();
   protected:
-    unsigned int tmp;
+    Parameter<unsigned int> &tmp;
   };
 
   class UnsignedIntsQuery : public Query {
   public:
-    UnsignedIntsQuery(std::string title, std::string _description = "");
+    UnsignedIntsQuery(Parameter<std::vector<unsigned int> > &, std::string title, std::string _description = "");
     virtual ~UnsignedIntsQuery();
     virtual bool handle()=0;
@@ -312,20 +313,20 @@
   protected:
     unsigned int temp;
-    std::vector<unsigned int> tmp;
+    Parameter<std::vector<unsigned int> > &tmp;
   };
 
   class DoubleQuery : public Query {
   public:
-    DoubleQuery(std::string title, std::string _description = "");
+    DoubleQuery(Parameter<double> &, std::string title, std::string _description = "");
     virtual ~DoubleQuery();
     virtual bool handle()=0;
     virtual void setResult();
   protected:
-    double tmp;
+    Parameter<double> &tmp;
   };
 
   class DoublesQuery : public Query {
   public:
-    DoublesQuery(std::string title, std::string _description = "");
+    DoublesQuery(Parameter<std::vector<double> > &, std::string title, std::string _description = "");
     virtual ~DoublesQuery();
     virtual bool handle()=0;
@@ -333,20 +334,20 @@
   protected:
     double temp;
-    std::vector<double> tmp;
+    Parameter<std::vector<double> > &tmp;
   };
 
   class StringQuery : public Query {
   public:
-    StringQuery(std::string title, std::string _description = "");
+    StringQuery(Parameter<std::string> &param, std::string title, std::string _description = "");
     virtual ~StringQuery();
     virtual bool handle()=0;
     virtual void setResult();
   protected:
-    std::string tmp;
+    Parameter<std::string> &tmp;
   };
 
   class StringsQuery : public Query {
   public:
-    StringsQuery(std::string title, std::string _description = "");
+    StringsQuery(Parameter<std::vector<std::string> > &param, std::string title, std::string _description = "");
     virtual ~StringsQuery();
     virtual bool handle()=0;
@@ -354,20 +355,20 @@
   protected:
     std::string temp;
-    std::vector<std::string> tmp;
+    Parameter<std::vector<std::string> > &tmp;
   };
 
   class MoleculeQuery : public Query {
   public:
-    MoleculeQuery(std::string title, std::string _description = "");
+    MoleculeQuery(Parameter<const molecule *> &param, std::string title, std::string _description = "");
     virtual ~MoleculeQuery();
     virtual bool handle()=0;
     virtual void setResult();
   protected:
-    const molecule *tmp;
+    Parameter<const molecule *> &tmp;
   };
 
   class MoleculesQuery : public Query {
   public:
-    MoleculesQuery(std::string title, std::string _description = "");
+    MoleculesQuery(Parameter<std::vector<const molecule *> > &param, std::string title, std::string _description = "");
     virtual ~MoleculesQuery();
     virtual bool handle()=0;
@@ -375,20 +376,20 @@
   protected:
     const molecule * temp;
-    std::vector<const molecule *> tmp;
+    Parameter<std::vector<const molecule *> > &tmp;
   };
 
   class AtomQuery : public Query {
   public:
-    AtomQuery(std::string title, std::string _description = "");
+    AtomQuery(Parameter<const atom *> &param, std::string title, std::string _description = "");
     virtual ~AtomQuery();
     virtual bool handle()=0;
     virtual void setResult();
   protected:
-    const atom *tmp;
+    Parameter<const atom *> &tmp;
   };
 
   class AtomsQuery : public Query {
   public:
-    AtomsQuery(std::string title, std::string _description = "");
+    AtomsQuery(Parameter<std::vector<const atom *> > &param, std::string title, std::string _description = "");
     virtual ~AtomsQuery();
     virtual bool handle()=0;
@@ -396,15 +397,15 @@
   protected:
     const atom *temp;
-    std::vector<const atom *> tmp;
+    Parameter<std::vector<const atom *> > &tmp;
   };
 
   class VectorQuery : public Query {
   public:
-      VectorQuery(std::string title,bool _check, std::string _description = "");
+      VectorQuery(Parameter<Vector> &param, std::string title,bool _check, std::string _description = "");
       virtual ~VectorQuery();
       virtual bool handle()=0;
       virtual void setResult();
     protected:
-      Vector tmp;
+      Parameter<Vector> &tmp;
       bool check;
   };
@@ -412,5 +413,5 @@
   class VectorsQuery : public Query {
   public:
-      VectorsQuery(std::string title,bool _check, std::string _description = "");
+      VectorsQuery(Parameter<std::vector<Vector> > &param, std::string title,bool _check, std::string _description = "");
       virtual ~VectorsQuery();
       virtual bool handle()=0;
@@ -418,31 +419,31 @@
     protected:
       Vector temp;
-      std::vector<Vector> tmp;
+      Parameter<std::vector<Vector> > &tmp;
       bool check;
   };
 
-  class BoxQuery : public Query {
-  public:
-      BoxQuery(std::string title, std::string _description = "");
-      virtual ~BoxQuery();
+  class RealSpaceMatrixQuery : public Query {
+  public:
+      RealSpaceMatrixQuery(Parameter<RealSpaceMatrix> &param, std::string title, std::string _description = "");
+      virtual ~RealSpaceMatrixQuery();
       virtual bool handle()=0;
       virtual void setResult();
     protected:
-      Box tmp;
+      Parameter<RealSpaceMatrix> &tmp;
   };
 
   class ElementQuery : public Query {
   public:
-    ElementQuery(std::string title, std::string _description = "");
+    ElementQuery(Parameter<const element*> &param, std::string title, std::string _description = "");
     virtual ~ElementQuery();
     virtual bool handle()=0;
     virtual void setResult();
   protected:
-    const element * tmp;
+    Parameter<const element *> &tmp;
   };
 
   class ElementsQuery : public Query {
   public:
-    ElementsQuery(std::string title, std::string _description = "");
+    ElementsQuery(Parameter<std::vector<const element *> > &param, std::string title, std::string _description = "");
     virtual ~ElementsQuery();
     virtual bool handle()=0;
@@ -450,35 +451,35 @@
   protected:
     const element *temp;
-    std::vector<const element *> tmp;
+    Parameter<std::vector<const element *> > &tmp;
   };
 
   class FileQuery : public Query {
   public:
-    FileQuery(std::string title, std::string _description = "");
+    FileQuery(Parameter<boost::filesystem::path> &param, std::string title, std::string _description = "");
     virtual ~FileQuery();
     virtual bool handle()=0;
     virtual void setResult();
   protected:
-    boost::filesystem::path tmp;
+    Parameter<boost::filesystem::path> &tmp;
   };
 
   class FilesQuery : public Query {
   public:
-    FilesQuery(std::string title, std::string _description = "");
+    FilesQuery(Parameter<std::vector<boost::filesystem::path> > &param, std::string title, std::string _description = "");
     virtual ~FilesQuery();
     virtual bool handle()=0;
     virtual void setResult();
   protected:
-    std::vector<boost::filesystem::path> tmp;
+    Parameter<std::vector<boost::filesystem::path> > &tmp;
   };
 
   class RandomNumberDistribution_ParametersQuery : public Query {
   public:
-    RandomNumberDistribution_ParametersQuery(std::string title, std::string _description = "");
+    RandomNumberDistribution_ParametersQuery(Parameter<RandomNumberDistribution_Parameters> &param, std::string title, std::string _description = "");
     virtual ~RandomNumberDistribution_ParametersQuery();
     virtual bool handle()=0;
     virtual void setResult();
   protected:
-    RandomNumberDistribution_Parameters tmp;
+    Parameter<RandomNumberDistribution_Parameters> &tmp;
   };
 
Index: src/UIElements/Makefile.am
===================================================================
--- src/UIElements/Makefile.am	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Makefile.am	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -5,5 +5,4 @@
   UIElements/CommandLineUI/Query/AtomsCommandLineQuery.cpp \
   UIElements/CommandLineUI/Query/BooleanCommandLineQuery.cpp \
-  UIElements/CommandLineUI/Query/BoxCommandLineQuery.cpp \
   UIElements/CommandLineUI/Query/DoubleCommandLineQuery.cpp \
   UIElements/CommandLineUI/Query/DoublesCommandLineQuery.cpp \
@@ -17,4 +16,5 @@
   UIElements/CommandLineUI/Query/MoleculeCommandLineQuery.cpp \
   UIElements/CommandLineUI/Query/MoleculesCommandLineQuery.cpp \
+  UIElements/CommandLineUI/Query/RealSpaceMatrixCommandLineQuery.cpp \
   UIElements/CommandLineUI/Query/StringCommandLineQuery.cpp \
   UIElements/CommandLineUI/Query/StringsCommandLineQuery.cpp \
@@ -75,5 +75,4 @@
   UIElements/TextUI/Query/AtomTextQuery.cpp \
   UIElements/TextUI/Query/BooleanTextQuery.cpp \
-  UIElements/TextUI/Query/BoxTextQuery.cpp \
   UIElements/TextUI/Query/DoubleTextQuery.cpp \
   UIElements/TextUI/Query/DoublesTextQuery.cpp \
@@ -87,4 +86,5 @@
   UIElements/TextUI/Query/MoleculesTextQuery.cpp \
   UIElements/TextUI/Query/MoleculeTextQuery.cpp \
+  UIElements/TextUI/Query/RealSpaceMatrixTextQuery.cpp \
   UIElements/TextUI/Query/StringTextQuery.cpp \
   UIElements/TextUI/Query/StringsTextQuery.cpp \
@@ -125,5 +125,4 @@
   UIElements/Query/AtomsQuery.cpp \
   UIElements/Query/BooleanQuery.cpp \
-  UIElements/Query/BoxQuery.cpp \
   UIElements/Query/DoubleQuery.cpp \
   UIElements/Query/DoublesQuery.cpp \
@@ -139,4 +138,5 @@
   UIElements/Query/Query.cpp \
   UIElements/Query/RandomNumberDistribution_ParametersQuery.cpp \
+  UIElements/Query/RealSpaceMatrixQuery.cpp \
   UIElements/Query/StringQuery.cpp \
   UIElements/Query/StringsQuery.cpp \
@@ -161,5 +161,4 @@
   UIElements/Qt4/Pipe/AtomsQtQueryPipe.cpp \
   UIElements/Qt4/Pipe/BooleanQtQueryPipe.cpp \
-  UIElements/Qt4/Pipe/BoxQtQueryPipe.cpp \
   UIElements/Qt4/Pipe/DoubleQtQueryPipe.cpp \
   UIElements/Qt4/Pipe/ElementsQtQueryPipe.cpp \
@@ -175,8 +174,8 @@
   UIElements/Qt4/Pipe/VectorsQtQueryPipe.cpp \
   UIElements/Qt4/Pipe/RandomNumberDistribution_ParametersQtQueryPipe.cpp \
+  UIElements/Qt4/Pipe/RealSpaceMatrixQtQueryPipe.cpp \
   UIElements/Qt4/Query/AtomQtQuery.cpp \
   UIElements/Qt4/Query/AtomsQtQuery.cpp \
   UIElements/Qt4/Query/BooleanQtQuery.cpp \
-  UIElements/Qt4/Query/BoxQtQuery.cpp \
   UIElements/Qt4/Query/DoubleQtQuery.cpp \
   UIElements/Qt4/Query/DoublesQtQuery.cpp \
@@ -190,4 +189,5 @@
   UIElements/Qt4/Query/MoleculeQtQuery.cpp \
   UIElements/Qt4/Query/MoleculesQtQuery.cpp \
+  UIElements/Qt4/Query/RealSpaceMatrixQtQuery.cpp \
   UIElements/Qt4/Query/StringQtQuery.cpp \
   UIElements/Qt4/Query/StringsQtQuery.cpp \
@@ -219,5 +219,4 @@
   UIElements/Qt4/Pipe/AtomsQtQueryPipe.hpp \
   UIElements/Qt4/Pipe/BooleanQtQueryPipe.hpp \
-  UIElements/Qt4/Pipe/BoxQtQueryPipe.hpp \
   UIElements/Qt4/Pipe/DoubleQtQueryPipe.hpp \
   UIElements/Qt4/Pipe/ElementQtQueryPipe.hpp \
@@ -229,4 +228,5 @@
   UIElements/Qt4/Pipe/MoleculesQtQueryPipe.hpp \
   UIElements/Qt4/Pipe/RandomNumberDistribution_ParametersQtQueryPipe.hpp \
+  UIElements/Qt4/Pipe/RealSpaceMatrixQtQueryPipe.hpp \
   UIElements/Qt4/Pipe/StringQtQueryPipe.hpp \
   UIElements/Qt4/Pipe/UnsignedIntQtQueryPipe.hpp \
@@ -269,4 +269,5 @@
 	$(BOOST_PROGRAM_OPTIONS_LDFLAGS) \
 	$(BOOST_RANDOM_LDFLAGS) \
+	$(BOOST_SERIALIZATION_LDFLAGS) 
 	$(BOOST_SYSTEM_LDFLAGS) \
 	$(BOOST_THREAD_LDFLAGS)
@@ -284,4 +285,5 @@
 	libMolecuilderFragmentation.la \
 	libMolecuilderParser.la \
+	libMolecuilderParameters.la \
 	libMolecuilderShapes.la \
 	libMolecuilderLinkedCell.la \
@@ -297,8 +299,9 @@
 libMolecuilderUI_la_LIBADD += \
 	${CodePatterns_LIBS} \
-	$(BOOST_SERIALIZATION_LDFLAGS) $(BOOST_SERIALIZATION_LIBS) \
-	$(BOOST_PROGRAM_OPTIONS_LDFLAGS) $(BOOST_PROGRAM_OPTIONS_LIBS) \
-	$(BOOST_FILESYSTEM_LDFLAGS) $(BOOST_FILESYSTEM_LIBS) \
-	$(BOOST_SYSTEM_LDFLAGS) $(BOOST_SYSTEM_LIBS)
+	$(BOOST_SERIALIZATION_LIBS) \
+	$(BOOST_PROGRAM_OPTIONS_LIBS) \
+	$(BOOST_FILESYSTEM_LIBS) \
+	$(BOOST_SYSTEM_LIBS) \
+	$(BOOST_THREAD_LIBS)
 
 nobase_libMolecuilderUI_la_include_HEADERS = ${UIHEADER}
Index: src/UIElements/Menu/Menu.cpp
===================================================================
--- src/UIElements/Menu/Menu.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Menu/Menu.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -106,5 +106,5 @@
 void Menu::populateActions()
 {
-  // go through all actions and add those beloning to this menu
+  // go through all actions and add those belonging to this menu
   ActionRegistry &AR = ActionRegistry::getInstance();
   for (ActionRegistry::const_iterator iter = AR.getBeginIter();
Index: src/UIElements/Menu/unittests/MenuDescription_ActionRegistry_ConsistencyUnitTest.cpp
===================================================================
--- src/UIElements/Menu/unittests/MenuDescription_ActionRegistry_ConsistencyUnitTest.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Menu/unittests/MenuDescription_ActionRegistry_ConsistencyUnitTest.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -26,4 +26,6 @@
 #include "Actions/ActionRegistry.hpp"
 #include "Actions/ActionTrait.hpp"
+#include "World.hpp"
+#include "WorldTime.hpp"
 
 #include "MenuDescription_ActionRegistry_ConsistencyUnitTest.hpp"
@@ -43,5 +45,5 @@
 void MenuDescription_ActionRegistry_ConsistencyTest::setUp()
 {
-  AR = ActionRegistry::getPointer();
+  CPPUNIT_ASSERT_NO_THROW(AR = ActionRegistry::getPointer());
 };
 
@@ -50,4 +52,9 @@
 {
   ActionRegistry::purgeInstance();
+  // these come about because of the validators accessing them instantiated
+  // by ActionRegistry. In ActionRegistryUnitTest we used stubs for them but
+  // here we care whether default values are actually valid.
+  World::purgeInstance();
+  WorldTime::purgeInstance();
 };
 
Index: src/UIElements/Qt4/Pipe/AtomQtQueryPipe.cpp
===================================================================
--- src/UIElements/Qt4/Pipe/AtomQtQueryPipe.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/AtomQtQueryPipe.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -28,5 +28,5 @@
 
 
-AtomQtQueryPipe::AtomQtQueryPipe(const atom **_content, QtDialog *_dialog, QComboBox *_theBox) :
+AtomQtQueryPipe::AtomQtQueryPipe(Parameter<const atom *> &_content, QtDialog *_dialog, QComboBox *_theBox) :
   content(_content),
   dialog(_dialog),
@@ -40,5 +40,5 @@
   QVariant data = theBox->itemData(newIndex);
   int idx = data.toInt();
-  (*content) = World::getInstance().getAtom(AtomById(idx));
+  content.set(World::getInstance().getAtom(AtomById(idx)));
   dialog->update();
 }
Index: src/UIElements/Qt4/Pipe/AtomQtQueryPipe.hpp
===================================================================
--- src/UIElements/Qt4/Pipe/AtomQtQueryPipe.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/AtomQtQueryPipe.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -15,4 +15,5 @@
 
 
+#include "Parameters/Parameter.hpp"
 #include <Qt/qwidget.h>
 
@@ -25,5 +26,5 @@
   Q_OBJECT
 public:
-  AtomQtQueryPipe(const atom **_content, QtDialog *_dialog, QComboBox *_theBox);
+  AtomQtQueryPipe(Parameter<const atom *> &_content, QtDialog *_dialog, QComboBox *_theBox);
   virtual ~AtomQtQueryPipe();
 
@@ -32,5 +33,5 @@
 
 private:
-  const atom **content;
+  Parameter<const atom *> &content;
   QtDialog *dialog;
   QComboBox *theBox;
Index: src/UIElements/Qt4/Pipe/AtomsQtQueryPipe.cpp
===================================================================
--- src/UIElements/Qt4/Pipe/AtomsQtQueryPipe.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/AtomsQtQueryPipe.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -30,5 +30,5 @@
 
 
-AtomsQtQueryPipe::AtomsQtQueryPipe(std::vector<const atom *>*_content, QtDialog *_dialog, QListWidget *_theList) :
+AtomsQtQueryPipe::AtomsQtQueryPipe(Parameter<std::vector<const atom *> > &_content, QtDialog *_dialog, QListWidget *_theList) :
   content(_content),
   dialog(_dialog),
@@ -41,7 +41,8 @@
 void AtomsQtQueryPipe::update() {
   // clear target and put all atoms therein
-  (*content).clear();
+  std::vector<const atom *> temp_atoms;
   for (std::set<const atom *>::iterator iter = currentList.begin(); iter != currentList.end(); ++iter)
-    (*content).push_back(*iter);
+    temp_atoms.push_back(*iter);
+  content.set(temp_atoms);
   dialog->update();
 }
@@ -53,5 +54,4 @@
     atom *Walker = World::getInstance().getAtom(AtomById(index));
     if (Walker) {
-      (*content).push_back(Walker);
       currentList.insert(Walker);
       if (lookup.find(index) != lookup.end())
Index: src/UIElements/Qt4/Pipe/AtomsQtQueryPipe.hpp
===================================================================
--- src/UIElements/Qt4/Pipe/AtomsQtQueryPipe.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/AtomsQtQueryPipe.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -15,4 +15,5 @@
 
 
+#include "Parameters/Parameter.hpp"
 #include <Qt/qwidget.h>
 
@@ -29,5 +30,5 @@
   Q_OBJECT
 public:
-  AtomsQtQueryPipe(std::vector<const atom *>*_content, QtDialog *_dialog, QListWidget *_theList);
+  AtomsQtQueryPipe(Parameter<std::vector<const atom *> > &_content, QtDialog *_dialog, QListWidget *_theList);
   virtual ~AtomsQtQueryPipe();
 
@@ -38,5 +39,5 @@
 
 private:
-  std::vector<const atom *>*content;
+  Parameter<std::vector<const atom *> > &content;
   std::map<int, const atom *> lookup;
   std::set<const atom *> currentList;
Index: src/UIElements/Qt4/Pipe/BooleanQtQueryPipe.cpp
===================================================================
--- src/UIElements/Qt4/Pipe/BooleanQtQueryPipe.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/BooleanQtQueryPipe.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -25,5 +25,5 @@
 #include "CodePatterns/MemDebug.hpp"
 
-BooleanQtQueryPipe::BooleanQtQueryPipe(bool *_content, QtDialog *_dialog, QCheckBox *_booleanCheckBox) :
+BooleanQtQueryPipe::BooleanQtQueryPipe(Parameter<bool> &_content, QtDialog *_dialog, QCheckBox *_booleanCheckBox) :
   content(_content),
   dialog(_dialog),
@@ -35,5 +35,5 @@
 
 void BooleanQtQueryPipe::update(int state) {
-  (*content) = (state == Qt::Checked);
+  content.set(state == Qt::Checked);
   dialog->update();
 }
Index: src/UIElements/Qt4/Pipe/BooleanQtQueryPipe.hpp
===================================================================
--- src/UIElements/Qt4/Pipe/BooleanQtQueryPipe.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/BooleanQtQueryPipe.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -15,4 +15,5 @@
 
 
+#include "Parameters/Parameter.hpp"
 #include <Qt/qwidget.h>
 
@@ -23,5 +24,5 @@
   Q_OBJECT
 public:
-  BooleanQtQueryPipe(bool *_content, QtDialog *_dialog, QCheckBox *_booleanCheckBox);
+  BooleanQtQueryPipe(Parameter<bool> &_content, QtDialog *_dialog, QCheckBox *_booleanCheckBox);
   virtual ~BooleanQtQueryPipe();
 
@@ -30,5 +31,5 @@
 
 private:
-  bool *content;
+  Parameter<bool> &content;
   QtDialog *dialog;
   QCheckBox *booleanCheckBox;
Index: src/UIElements/Qt4/Pipe/DoubleQtQueryPipe.cpp
===================================================================
--- src/UIElements/Qt4/Pipe/DoubleQtQueryPipe.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/DoubleQtQueryPipe.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -23,5 +23,5 @@
 #include "CodePatterns/MemDebug.hpp"
 
-DoubleQtQueryPipe::DoubleQtQueryPipe(double *_content, QtDialog *_dialog) :
+DoubleQtQueryPipe::DoubleQtQueryPipe(Parameter<double> &_content, QtDialog *_dialog) :
   content(_content),
   dialog(_dialog)
@@ -32,5 +32,5 @@
 
 void DoubleQtQueryPipe::update(double newDbl) {
-  (*content) = newDbl;
+  content.set(newDbl);
   dialog->update();
 }
Index: src/UIElements/Qt4/Pipe/DoubleQtQueryPipe.hpp
===================================================================
--- src/UIElements/Qt4/Pipe/DoubleQtQueryPipe.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/DoubleQtQueryPipe.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -15,4 +15,5 @@
 
 
+#include "Parameters/Parameter.hpp"
 #include <Qt/qwidget.h>
 
@@ -22,5 +23,5 @@
   Q_OBJECT
 public:
-  DoubleQtQueryPipe(double *_content, QtDialog *_dialog);
+  DoubleQtQueryPipe(Parameter<double> &_content, QtDialog *_dialog);
   virtual ~DoubleQtQueryPipe();
 
@@ -29,5 +30,5 @@
 
 private:
-  double *content;
+  Parameter<double> &content;
   QtDialog *dialog;
 
Index: src/UIElements/Qt4/Pipe/ElementQtQueryPipe.cpp
===================================================================
--- src/UIElements/Qt4/Pipe/ElementQtQueryPipe.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/ElementQtQueryPipe.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -29,5 +29,5 @@
 
 
-ElementQtQueryPipe::ElementQtQueryPipe(const element **_content, QtDialog *_dialog, QComboBox *_theBox) :
+ElementQtQueryPipe::ElementQtQueryPipe(Parameter<const element *> &_content, QtDialog *_dialog, QComboBox *_theBox) :
   content(_content),
   dialog(_dialog),
@@ -41,5 +41,5 @@
   QVariant data = theBox->itemData(newIndex);
   int idx = data.toInt();
-  *content = World::getInstance().getPeriode()->FindElement(idx);
+  content.set(World::getInstance().getPeriode()->FindElement(idx));
   dialog->update();
 }
Index: src/UIElements/Qt4/Pipe/ElementQtQueryPipe.hpp
===================================================================
--- src/UIElements/Qt4/Pipe/ElementQtQueryPipe.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/ElementQtQueryPipe.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -15,4 +15,5 @@
 
 
+#include "Parameters/Parameter.hpp"
 #include <Qt/qwidget.h>
 
@@ -25,5 +26,5 @@
   Q_OBJECT
 public:
-  ElementQtQueryPipe(const element **_content, QtDialog *_dialog, QComboBox *_theBox);
+  ElementQtQueryPipe(Parameter<const element *> &_content, QtDialog *_dialog, QComboBox *_theBox);
   virtual ~ElementQtQueryPipe();
 
@@ -32,5 +33,5 @@
 
 private:
-  const element **content;
+  Parameter<const element *> &content;
   QtDialog *dialog;
   QComboBox *theBox;
Index: src/UIElements/Qt4/Pipe/ElementsQtQueryPipe.cpp
===================================================================
--- src/UIElements/Qt4/Pipe/ElementsQtQueryPipe.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/ElementsQtQueryPipe.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -31,5 +31,5 @@
 
 
-ElementsQtQueryPipe::ElementsQtQueryPipe(std::vector<const element *>*_content, QtDialog *_dialog, QComboBox *_theBox) :
+ElementsQtQueryPipe::ElementsQtQueryPipe(Parameter<std::vector<const element *> > &_content, QtDialog *_dialog, QComboBox *_theBox) :
   content(_content),
   dialog(_dialog),
@@ -44,6 +44,8 @@
   int idx = data.toInt();
   const element *elemental = World::getInstance().getPeriode()->FindElement(idx);
+  std::vector<const element *> temp_elements;
   if(elemental)
-    (*content).push_back(elemental);
+    temp_elements.push_back(elemental);
+  content.set(temp_elements);
   dialog->update();
 }
Index: src/UIElements/Qt4/Pipe/ElementsQtQueryPipe.hpp
===================================================================
--- src/UIElements/Qt4/Pipe/ElementsQtQueryPipe.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/ElementsQtQueryPipe.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -15,4 +15,5 @@
 
 
+#include "Parameters/Parameter.hpp"
 #include <Qt/qwidget.h>
 
@@ -28,5 +29,5 @@
   Q_OBJECT
 public:
-  ElementsQtQueryPipe(std::vector<const element *>*_content, QtDialog *_dialog, QComboBox *_theBox);
+  ElementsQtQueryPipe(Parameter<std::vector<const element *> > &_content, QtDialog *_dialog, QComboBox *_theBox);
   virtual ~ElementsQtQueryPipe();
 
@@ -35,5 +36,5 @@
 
 private:
-  std::vector<const element *>*content;
+  Parameter<std::vector<const element *> > &content;
   QtDialog *dialog;
   QComboBox *theBox;
Index: src/UIElements/Qt4/Pipe/FileQtQueryPipe.cpp
===================================================================
--- src/UIElements/Qt4/Pipe/FileQtQueryPipe.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/FileQtQueryPipe.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -31,5 +31,5 @@
 #include "UIElements/Qt4/QtDialog.hpp"
 
-FileQtQueryPipe::FileQtQueryPipe(boost::filesystem::path *_content, QtDialog *_dialog, QLineEdit *_filenameLineEdit, QPushButton *_filedialogButton) :
+FileQtQueryPipe::FileQtQueryPipe(Parameter<boost::filesystem::path> &_content, QtDialog *_dialog, QLineEdit *_filenameLineEdit, QPushButton *_filedialogButton) :
   content(_content),
   dialog(_dialog),
@@ -49,6 +49,6 @@
   QStringList ListOfFilenames = theFileDialog->selectedFiles();
   std::cout << "Selected File is " << ListOfFilenames.at(0).toStdString() << std::endl;
-  (*content) = ListOfFilenames.at(0).toStdString();
-  filenameLineEdit->setText(QString::fromStdString((*content).string()));
+  content.set(ListOfFilenames.at(0).toStdString());
+  filenameLineEdit->setText(QString::fromStdString(content.get().string()));
   dialog->update();
 }
Index: src/UIElements/Qt4/Pipe/FileQtQueryPipe.hpp
===================================================================
--- src/UIElements/Qt4/Pipe/FileQtQueryPipe.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/FileQtQueryPipe.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -15,4 +15,5 @@
 
 
+#include "Parameters/Parameter.hpp"
 #include <Qt/qwidget.h>
 
@@ -27,5 +28,5 @@
   Q_OBJECT
 public:
-  FileQtQueryPipe(boost::filesystem::path *_content, QtDialog *_dialog, QLineEdit *_filenameLineEdit, QPushButton *_filedialogButton);
+  FileQtQueryPipe(Parameter<boost::filesystem::path> &_content, QtDialog *_dialog, QLineEdit *_filenameLineEdit, QPushButton *_filedialogButton);
   virtual ~FileQtQueryPipe();
 
@@ -35,5 +36,5 @@
 
 private:
-  boost::filesystem::path *content;
+  Parameter<boost::filesystem::path> &content;
   QtDialog *dialog;
   QLineEdit *filenameLineEdit;
